/*
Copyright (c) 1993-2008, Cognitive Technologies
All rights reserved.

         ,
    ,    ,    :

      *        
            ,     
          .
      *        / 
         ,   ,  
             ,    
           .
      *   Cognitive Technologies,      
              / 
        ,    ,   
        .

      /   "
 "  -  ,    ,
        ,  
 .         , 
  /   ,     
Ѩ ,   , ,  
 ,      
   (  ,  ,
 ,   /  ,  - 
  /       ,
    ),    ,   
           .

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation
      and/or other materials provided with the distribution.
    * Neither the name of the Cognitive Technologies nor the names of its
      contributors may be used to endorse or promote products derived from this
      software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

// CTIMask.h: interface for the CTIMask class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(_CTIMASK_H_)
#define _CTIMASK_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

# if defined (_DEBUG)
# pragma message( __FILE__" : Image mask")
# endif // (_DEBUG)
//////////////////////////////////////////////////////////////////////////////////
#include "resource.h"
#include "ctidefines.h"
#include "ctiimage.h"
#include "ctimemory.h"
#include "ctimaskline.h"
////////////////////////////////////////////////////////////////////////////////////
class CTIMask;
typedef CTIMask  *PCTIMask, **PPCTIMask;

class CTIMask
{
public:
	Bool32 GetLine(Word32 wLine, PPCTIMaskLine ppcLine);
	Bool32        IsRectOnMask(PCIMAGE_Rect pRect);
	Bool32        RemoveRectangle(PCIMAGE_Rect pRect);
	Bool32        AddRectangle(PCIMAGE_Rect pRect);
	CTIMask(Word32 Width, Word32 Height);
	CTIMask();
	virtual ~CTIMask();

protected:
	CTIMaskLine mcLine;
	Word32 mwMaskHeight;
	Word32 mwMaskWidth;
	Word32 mwSegments;
	Word32 mwLines;
private:
	Bool32 SetPtrToPrevLine(Word32 wLine, PPCTIMaskLine ppLine);
};

#endif // !defined(_CTIMASK_H_)
