/*
Copyright (c) 1993-2008, Cognitive Technologies
All rights reserved.

         ,
    ,    ,    :

      *        
            ,     
          .
      *        / 
         ,   ,  
             ,    
           .
      *   Cognitive Technologies,      
              / 
        ,    ,   
        .

      /   "
 "  -  ,    ,
        ,  
 .         , 
  /   ,     
Ѩ ,   , ,  
 ,      
   (  ,  ,
 ,   /  ,  - 
  /       ,
    ),    ,   
           .

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation
      and/or other materials provided with the distribution.
    * Neither the name of the Cognitive Technologies nor the names of its
      contributors may be used to endorse or promote products derived from this
      software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef __BLOCK_H__
#define __BLOCK_H__

#include "cpage.h"
#include "data.h"

/////////////////////////////////////////////////////
class BLOCK: public DATA
{
public:
	Word32 UserNum;
	Word32 Flags;
	Word32 InterNum;


public:
	BLOCK();
	~BLOCK();

	Bool32  Create(Handle Type, Word32 UserNum = 0, Word32 Flags = 0,void * lpData = NULL, Word32 Size = 0);

	Handle  GetType() { return DATA::GetType();};
	Word32  GetUserNum() { return UserNum;};
	void    SetUserNum(Word32 user) { UserNum = user;};
	Word32  GetFlags() { return Flags;};
	void    SetFlags(Word32 flags) { Flags = flags;};
	Word32  GetInterNum() { return InterNum;};
	void    SetInterNum(Word32 user) { InterNum = user;};

	BLOCK & operator = (BLOCK & Block);
	Bool32  operator == (BLOCK & Block);

	Bool32 Save(Handle to);
	Bool32 Restore(Handle from);
	Bool32 SaveCompress(Handle to);
	Bool32 RestoreCompress(Handle from);

	virtual Word32 Convert(Handle type,void * lpdata,Word32 size);
};

	CPAGE_CONVERTOR SetConvertorBlocks(CPAGE_CONVERTOR convertor);

#endif
