/*
Copyright (c) 1993-2008, Cognitive Technologies
All rights reserved.

         ,
    ,    ,    :

      *        
            ,     
          .
      *        / 
         ,   ,  
             ,    
           .
      *   Cognitive Technologies,      
              / 
        ,    ,   
        .

      /   "
 "  -  ,    ,
        ,  
 .         , 
  /   ,     
Ѩ ,   , ,  
 ,      
   (  ,  ,
 ,   /  ,  - 
  /       ,
    ),    ,   
           .

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation
      and/or other materials provided with the distribution.
    * Neither the name of the Cognitive Technologies nor the names of its
      contributors may be used to endorse or promote products derived from this
      software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef __RCORRKEGL_H
#define __RCORRKEGL_H

#ifndef __GLOBUS_H
#include "globus.h"
#endif

#ifdef __RCORRKEGL__
  #define RCK_FUNC  FUN_EXPO
#else
  #define RCK_FUNC  FUN_IMPO
#endif

#ifdef __cplusplus
	extern "C" {
#endif

#pragma pack (push,8)

    enum RCORRKEGLImp
        {
        RCORRKEGL_FNIMP_LANGUAGE,
        RCORRKEGL_Bool32_Fax100
        };

RCK_FUNC(Bool32) RCORRKEGL_Init(Word16 wHeightCode,Handle hStorage);
RCK_FUNC(Bool32) RCORRKEGL_Done();
RCK_FUNC(Word32) RCORRKEGL_GetReturnCode();
RCK_FUNC(Int8 *) RCORRKEGL_GetReturnString(Word32 dwError);
RCK_FUNC(Bool32) RCORRKEGL_SetImportData(Word32 dwType, void * pData);

RCK_FUNC(Bool32) RCORRKEGL_CorrectKegl(Int32 version);

#pragma pack (pop)

#ifdef __cplusplus
            }
#endif

// error codes
#define RCORRKEGL_ERR_MIN                2048
#define RCORRKEGL_ERR_NO                 2048
#define RCORRKEGL_ERR_NOTIMPLEMENT       2049
#define RCORRKEGL_ERR_MAX                2049

#endif
