/*
Copyright (c) 1993-2008, Cognitive Technologies
All rights reserved.

         ,
    ,    ,    :

      *        
            ,     
          .
      *        / 
         ,   ,  
             ,    
           .
      *   Cognitive Technologies,      
              / 
        ,    ,   
        .

      /   "
 "  -  ,    ,
        ,  
 .         , 
  /   ,     
Ѩ ,   , ,  
 ,      
   (  ,  ,
 ,   /  ,  - 
  /       ,
    ),    ,   
           .

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation
      and/or other materials provided with the distribution.
    * Neither the name of the Cognitive Technologies nor the names of its
      contributors may be used to endorse or promote products derived from this
      software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef _ALPHABET_H_
#define _ALPHABET_H_

typedef struct { INT dig,fuzzy_dig,all,alphabet,dollars,pm;} str_info;

void  add_digital_versions(void);
void   copy_alphabet(PBYTE);
BOOL   test_alphabet_elem(BYTE let);
void del_punct_and_last_context(void);
void clear_digital_mode(void);
void set_digital_mode(void);
void set_digital_alphabet(void);
void set_all_alphabet(void);
void add_alphabet_elem(BYTE let);
void del_alphabet_elem(BYTE let);
void save_alphabet_information(str_info *s,INT num,CSTR_line ln);
void save_alphabet_information_pass2(str_info *s,INT num,CSTR_line ln);
INT  GetColumn(INT *VertLines,INT VertNum);
void make_simples_diff(INT lang);
INT  dichotomy_array(INT value,INT *array,INT start,INT end);
void set_column_alphabets(str_info *str_inf,INT VertNum);
void set_column_alphabets_pass2(str_info *str_inf,INT VertNum);
void setup_digital_mode(str_info *str, INT first_pass);
void setup_digital_mode_pass2(str_info *str, INT first_pass);
BOOL digital_last_context(void);



#define ALPHA_ALL           0
#define ALPHA_DIGITAL       1
#define ALPHA_DIGITAL_TRUE  2
#define ALPHA_PLUS_MINUS    3
#define ALPHA_YES_NO        4

#endif
