/*
Copyright (c) 1993-2008, Cognitive Technologies
All rights reserved.

         ,
    ,    ,    :

      *        
            ,     
          .
      *        / 
         ,   ,  
             ,    
           .
      *   Cognitive Technologies,      
              / 
        ,    ,   
        .

      /   "
 "  -  ,    ,
        ,  
 .         , 
  /   ,     
Ѩ ,   , ,  
 ,      
   (  ,  ,
 ,   /  ,  - 
  /       ,
    ),    ,   
           .

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation
      and/or other materials provided with the distribution.
    * Neither the name of the Cognitive Technologies nor the names of its
      contributors may be used to endorse or promote products derived from this
      software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef	_C_T_P_
#define _C_T_P_

#define CTP_FILE_NAME	"cunei$.ctp"

struct ctp_hdr {
	#define SIGNA	"CT Picture"
	BYTE Signatura[10];
	};

struct ctp_pic_hdr {
DWORD	pic_size;	// in bytes
WORD	x_off;		// in pixels
WORD	y_off;		// in pixels
WORD	w;		// in pixels
WORD	h;		// in pixels
WORD	resolution;
WORD	bpl;		// bytes per line. Only if native format
BYTE    bitpix;
BYTE	type;
#define ctp_BW          0
#define ctp_greytone    1
#define ctp_color	2
#define ctp_2xx		10 // compressed
#define ctp_4xx		11 // contured
#define ctp_native      64 /* if type less this const
			      It one of native formats */
#define ctp_tiff        65
#define ctp_gif         66
#define ctp_pcx         67
#define ctp_bmp         68
#define ctp_wmf		69
#define ctp_jpeg	70
BYTE    PicName[32];
};

typedef struct ctp_pic_hdr	pic_id;

#define strip_H	16

typedef struct {
	WORD len; // strip len in bytes
	WORD col; // begining of strip from strip_header.left(in bytes)
	 } strip;

typedef struct {
	WORD top; // adjusted to strip_H bound
	WORD left;
	WORD n_strip;
	WORD handle;
	 } strip_header;

#endif  // _C_T_P_
